

import data, ioengine
import pygame, math
from pygame.locals import *

def magdir((x,y)):
    mag=math.hypot(x,y)
    if mag:
        dir=(x/mag,y/mag)
    else: 
        dir = (0,0)
    return mag,dir

def mult(tup,amt):
    return (tup[0]*amt,tup[1]*amt)

def collision(b1,b2):
    if (b1.pos[0]-b2.pos[0])**2+(b1.pos[1]-b2.pos[1])**2<=(b1.radius+b2.radius)**2:
        
        bm1,bd1=magdir(b1.vel)
        bm2,bd2=magdir(b2.vel)
        mm,md=magdir((b1.pos[0]-b2.pos[0],b1.pos[1]-b2.pos[1]))
        b1.vel=mult(md,(bm2+0.01))
        b2.vel=mult(md,-(bm1+0.01))
        
        

class block:
    def __init__(self):
        self.pos=(400,300)
        self.radius=20
        self.acc=(0,0)
        self.vel=(0,0)
        
    def draw(self,screen):
        pygame.draw.circle(screen,(200,200,100),(int(self.pos[0]),int(self.pos[1])),self.radius)
        
    
    def update(self):
        self.vel=(self.vel[0]+self.acc[0],self.vel[1]+self.acc[1])
        self.pos=(self.pos[0]+self.vel[0],self.pos[1]+self.vel[1])
        self.acc=(self.acc[0]*0.9,self.acc[1]*0.9)
        self.vel=(self.vel[0]*0.94,self.vel[1]*0.94)


def main():
    pygame.init()
    clock=pygame.time.Clock()
    screen=pygame.display.set_mode((800,600))
    enemylist=[block()]
    bob=block()
    bob.pos=(50,40)
    ioe=ioengine.ioe()
    
    while not ioe.quit:
        clock.tick(30)
        screen.fill((64,64,128))
        ioe.update(pygame.event.get())
        pygame.draw.circle(screen,(96,96,132),(700,400),int(abs(bob.vel[0])+abs(bob.vel[1])))
        pygame.draw.circle(screen,(96,96,132),(500,400),int(abs(bob.acc[0]*10)+abs(bob.acc[1]*10)))
        bob.update()
        
        
        for e in enemylist:
            e.update()
            collision(e,bob)
            e.draw(screen)
            
        bob.draw(screen)
        for k in ioe.down:
            if k==K_LEFT:
                bob.acc=(bob.acc[0]-1.2,bob.acc[1])
            elif k==K_RIGHT:
                bob.acc=(bob.acc[0]+1.2,bob.acc[1])
            elif k==K_UP:
                bob.acc=(bob.acc[0],bob.acc[1]-1.2)
            elif k==K_DOWN:
                bob.acc=(bob.acc[0],bob.acc[1]+1.2)
        for k in ioe.pressed:
            if k==K_LEFT:
                bob.vel=(bob.vel[0]-0.35,bob.vel[1])
            elif k==K_RIGHT:
                bob.vel=(bob.vel[0]+0.35,bob.vel[1])
            elif k==K_UP:
                bob.vel=(bob.vel[0],bob.vel[1]-0.35)
            elif k==K_DOWN:
                bob.vel=(bob.vel[0],bob.vel[1]+0.35)
        #~ for k in ioe.up:
            #~ if k==K_LEFT or k==K_RIGHT:
                #~ bob.vel=(bob.vel[0]*0.5,bob.vel[1])
            #~ elif k==K_UP or k==K_DOWN:
                #~ bob.vel=(bob.vel[0],round(bob.vel[1])*0.5)
        pygame.display.flip()
    
if __name__ == "__main__":
    main()